#include <stdio.h>
#include <stdlib.h>
#include "sqlite3.h"

static FILE *filehandle = NULL;

void sqlite3_plot_step(sqlite3_context *context, int argc, sqlite3_value **argv) {
	const unsigned char *title = "SQLite";
	const unsigned char *linetype = "points";
	if(argc > 2) {
		title = sqlite3_value_text(argv[2]);
	}
	if(argc > 3) {
		linetype = sqlite3_value_text(argv[3]);
	}
	if(NULL == filehandle) {
		char cmd[2048];
		snprintf(cmd, sizeof(cmd), "gnuplot -p -e \"plot '-' u 1:2 t \\\"%s\\\" w %s \"", title, linetype);
		filehandle = popen(cmd, "w");
	}
	const unsigned char *val_a = sqlite3_value_text(argv[0]);
	const unsigned char *val_b = sqlite3_value_text(argv[1]);
	fprintf(filehandle, "%s %s\n", val_a, val_b);
}

void sqlite3_plot_final(sqlite3_context *context) {
	// FILE **filehandle = sqlite3_user_data(context);
	if(NULL == filehandle) {
		return;
	}
	fprintf(filehandle, "e\n");
	pclose(filehandle);
	filehandle = NULL;
}

